// -*- C++ -*-
/*!
 * @file RTObject.cpp
 * @brief RT component base class
 * @date $Date: 2006/09/11 19:04:29 $
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2006
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id: RTObject.cpp,v 1.1 2006/09/11 19:04:29 n-ando Exp $
 *
 */

/*
 * $Log: RTObject.cpp,v $
 * Revision 1.1  2006/09/11 19:04:29  n-ando
 * The first commit.
 *
 *
 */



namespace RTC
{
  class DataFlowParticipantType
    : public virtual POA_RTC::DataFlowParticipant
  {
  public:
    virtual ReturnCode_t on_execute(UniqueId ec_id)
    {
      return RTC::OK;
    }

    virtual ReturnCode_t on_state_update(UniqueId ec_id)
    {
      return RTC::OK;
    }

    virtual ReturnCode_t on_rate_changed(UniqueId ec_id)
    {
      return RTC::OK;
    }

  protected:
    virtual ReturnCode_t onExecute(UniqueId ec_id)
    {
      return RTC::OK;
    }

    virtual ReturnCode_t onStateUpdate(UniqueId ec_id)
    {
      return RTC::OK;
    }

    virtual ReturnCode_t onRateChanged(UniqueId ec_id)
    {
      return RTC::OK;
    }
  };


  class DataFlowCompositeType
    : public virtual POA_RTC::DataFlowComposite
  {
  };


  class FsmParticipantType
    : pbulic virtual POA_RTC::FsmParticipant
  {
  public:
    ReturnCode_t on_transition(LightweightRTObject_ptr comp, UniqueId ec_id)
    {
      return RTC::OK;
    }
  protected:
    ReturnCode_t onTransition(LightweightRTObject_ptr comp, UniqueId ec_id)
    {
      return RTC::OK;
    }
  };

  public:  public:
    ReturnCode_t on_transition(LightweightRTObject_ptr comp, UniqueId ec_id)
    {
      return RTC::OK;
    }

    ReturnCode_t on_transition(LightweightRTObject_ptr comp, UniqueId ec_id)
    {
      return RTC::OK;
    }

  class FsmType
    : public virtual POA_RTC::Fsm
  {

  };


  class ModeType
    : public virtual POA_RTC::Mode
  {
  };


  class MultiModeObject
    : public virtual POA_RTC::MultiModeObjectType
  {
  };



  template <class CompType>
  class RtcBase
    : public virtual CompType,
      public virtual RTObject_impl
  {
  }
   

};
